﻿using System.Collections.Generic;
using System.Collections.ObjectModel;
using Telerik.XamarinForms.Common;
using Xamarin.Forms;
using Xamarin.Forms.Xaml;

namespace ItemsCodeBehind.Portable
{
    [XamlCompilation(XamlCompilationOptions.Compile)]
    public partial class DataBindingDemo : ContentPage
    {
        private ObservableCollection<MySlideViewItem> mySlideViewItems;

        public DataBindingDemo()
        {
            InitializeComponent();

            mySlideViewItems = new ObservableCollection<MySlideViewItem>
            {
                new MySlideViewItem
                {
                    Id = 1,
                    PickerItems = new List<string> {"Green", "Blue", "Orange", "Yellow"},
                    SelectedPickerIndex = 1
                },
                new MySlideViewItem
                {
                    Id = 2,
                    PickerItems = new List<string> {"Winter", "Spring", "Summer", "Fall"},
                    SelectedPickerIndex = 1
                }
            };

            slideView.ItemsSource = mySlideViewItems;
        }
    }

    // This is a class is to hold properties that are bound to the content of each slide
    public class MySlideViewItem : NotifyPropertyChangedBase
    {
        private int _id;
        private List<string> _pickerItems;
        private int _selectedPickerIndex;

        public int Id
        {
            get => _id;
            set
            {
                if (_id != value)
                {
                    _id = value;
                    OnPropertyChanged();
                }
            }
        }

        public List<string> PickerItems
        {
            get => _pickerItems;
            set
            {
                if (_pickerItems != value)
                {
                    _pickerItems = value;
                    OnPropertyChanged();
                }
            }
        }

        public int SelectedPickerIndex
        {
            get => _selectedPickerIndex;
            set
            {
                if (_selectedPickerIndex != value)
                {
                    _selectedPickerIndex = value;
                    OnPropertyChanged();
                }
            }
        }
    }
}